
Ca ********************************************************************
Ca ********************************************************************
Ca ********************************************************************
Ca ********************************************************************
Ca ********************************************************************

      subroutine yji_ctf1dfit(npix_col,npix_row,num_img,fftSizeCall,
     +     pixelSizeCall, voltCall, res_hiCall, defMajorCall,
     +     ampContrastCall, CsCall, packImgCall, chisqCall, 
     +     aPass,
     +     adr_s, adr_sminusb, adr_ctfsq, adr_d, adr_b, ca1d_pass,
     +     calcIt, saveFftAvg )
C     **********************************************************************
C *   1. read images from one image file and do 2D FFT                 *
C *   2. average these 2D FFTs                                         *
C *   3. calculate some stats and writeout                             *
C *                                                                    *
C **********************************************************************
      implicit none
C     
      INCLUDE '../include/allprogs.inc'
      include 'mem_time.inc'
C     

      Character*8   subname
      DATA subNAME / '    ' /
C
C Local variables, used only in the main routine
C
      real  adr_s(1024), adr_sminusb(1024)
      real  ca1d_pass(1024)
      real  adr_ctfsq(1024), adr_d(1024), adr_b(1024) 
      integer mm, displayScale
      integer calcIt
      integer alloc_stat1, alloc_stat2
      real    saveFftAvg(1)
C     
      real, allocatable :: rffta_omega(:)
      real, allocatable :: fftavg(:)
      complex, allocatable :: fft2d(:)
C     real, allocatable :: pixels(:)
      
      double precision, allocatable :: poly_paras(:)
      double precision, allocatable :: ca1d_avg(:)
      double precision, allocatable :: ca1d_std(:)
C     
      character(len=256) infile, outfile
      
      integer fftSizeCall,m,n
      real    pixelSizeCall, voltCall, res_hiCall
      real    pixels(npix_col,npix_row)
      real    aPass(13)
      real    defMajorCall
      real    ampContrastCall, CsCall, chisqCall
      real    packImgCall(npix_col, npix_row, num_img)
      integer npix_col, npix_row, num_img, nrffta_row,nrffta_col,
     +     nrffta_omega, nfc_2d_row, nfc_2d_col, hkl_min, hkl_max,
     +     i, j , mem_size, annlow, annhigh, ndata
      integer itemp, itemp2, poly_orderb, poly_orderd, poly_order
      double precision pixel_size, voltage, defocus, res_hi, reslow,
     +     fw, fw2, wavelength, a, cs, chisq
      real    img_avg, img_std, rtemp, rtemp1
      real    tmp5, tmp6, B, D, theta, ctf, ctf2
      real PI
      
      double precision elapsed_time
      integer clock1, clock2, clock3
      
      
C *********************************************************************
C *                      Initialization                               *
C *********************************************************************
      PROGNAME = 'fftavgr'
      test_time   = .true.
      test_memory = .true.
      PI = 3.14159265358979323
Ca      call usage
C
      call system_clock(clock1)
C
C --------------------------------------------------------------------
C     read input image file name and out put file name
Ca  100 print *, 'Enter Input image FILENAME: '
Ca      READ (*,'(A)',ERR=100) infile
Ca      print *, 'Input image FILENAME: ', infile
C
Ca      IMGHEAD.LUNUM = pix_file_unit
Ca      CALL PIF_OPEN (infile, IMGHEAD.LUNUM, 'r')
Ca      CALL PIF_READ_GH (IMGHEAD)
Ca      npix_col  = IMGHEAD.NUMCOLS
Ca      npix_row  = IMGHEAD.NUMROWS
Ca      num_img   = IMGHEAD.nimg
      print *, 'col,row,nimg = ', npix_col,npix_row,num_img

C
Ca  101 print *, 'Enter Output fited FILENAME: '
Ca      READ (*,'(A)',ERR=101) outfile
Ca      print *, 'Output fited FILENAME: ', outfile

C --------------------------------------------------------------------
C     read and determine the fft size
Ca  300 print *, 'Enter FFT size:'
Ca      READ (*,*,ERR=300) itemp
Ca      if (itemp .LT. npix_col) goto 300
      itemp = fftSizeCall
      call TRANS_LENGTH_ESSL( itemp, nrffta_row )
      print *, ' FFT size =',nrffta_row
C 
      nfc_2d_row   = nrffta_row/2
      nfc_2d_col   = nfc_2d_row
      hkl_min      = - nfc_2d_row
      hkl_max      = nfc_2d_row
      nrffta_col   = nrffta_row
      nrffta_omega = nrffta_col + 15
C --------------------------------------------------------------------
C     read pixel size 
Ca  301 print *, 'Enter pixel_size (A):'
Ca      READ (*,*,ERR=301) rtemp
      rtemp = pixelSizeCall
      pixel_size = rtemp
      print *, ' pixel_size =', pixel_size
C --------------------------------------------------------------------
C     read voltage 
Ca  302 print *, 'Enter voltagei (V):'
Ca      READ (*,*,ERR=302) rtemp
      rtemp = voltCall
      voltage = rtemp
      print *, ' voltage =', voltage
C --------------------------------------------------------------------
C     read guess defocus value
Ca  303 print *, 'Enter guessed defocus value (A):'
Ca      READ (*,*,ERR=303) rtemp
      rtemp = defMajorCall
      defocus = rtemp
      print *, ' guessed defocus value =', defocus
C --------------------------------------------------------------------
C     read highest resolution you want to fit
Ca  304 print *, 'Enter highest resolution you want to fit (A):'
Ca      READ (*,*,ERR=304) rtemp
      rtemp = res_hiCall
      res_hi = rtemp
      print *, ' highest resolution =', res_hi
C --------------------------------------------------------------------
C     Percentage of Amplitude Contrast & Spherical aberration constant
      A = 0.05
      Cs = 20000000.0     
Ca  314 print *,'Enter Amplitude Contrast & Spherical aberration constant'
Ca      print *, '(e.g. 0.05, 20000000.0):'
Ca      READ (*,*,ERR=314) rtemp, rtemp1
      rtemp = ampContrastCall
      rtemp1 = CsCall
      A   = rtemp
      Cs  = rtemp1
      print *, 'Percentage Amp Contrast =', rtemp, '  Cs =', rtemp1
C --------------------------------------------------------------------
C     read The order of polynomial to fit the background B, 
Cji   and The order of polynomial to fit signal strengh decay D
Ca  305 print *,'Enter order of polynomial to fit Background & Decay:'
Ca      READ (*,*,ERR=305) itemp, itemp2
Ca      if (itemp .LE. 0 .or. itemp2 .le. 0) goto 305
      itemp = 5
      itemp2 = 5
      poly_orderb = itemp
      poly_orderd = itemp2
      print *, ' Order of Background =', poly_orderb 
      print *, ' Order of signal strengh decay =', poly_orderd 
C --------------------------------------------------------------------
C     read The Initial Parameters for polynomial functions of B & D, 
      poly_orderb  = poly_orderb + 1 
      poly_orderd  = poly_orderd + 1 
      poly_order  = poly_orderb + poly_orderd + 1
      allocate(poly_paras(poly_order), stat=alloc_stat1)
Ca  306 print *,'Enter Initial Parameters B&D for polynomial functions:'
Ca      READ (*,*,ERR=306) (poly_paras(j),j=1,poly_order-1)
      do j = 1,poly_order-1
         poly_paras(j) = aPass(j)
      enddo

      print *, 'Initial Parameters B&D for polynomial functions:',
     +     (poly_paras(j),j=1,poly_order-1)
Cji   according to the subroutine, the last of parameter is used for defocus value
      poly_paras(poly_order) = defocus
C --------------------------------------------------------------------
Cji   alloc memory
      allocate(rffta_omega(nrffta_omega), stat=alloc_stat1)
      if(alloc_stat1 > 0) call error(progname, subname,
     +     'Error in allocating memory for nrffta_omega')
C
      mem_size   = npix_col * npix_row 
Ca    allocate(pixels(mem_size), stat=alloc_stat1)
C
Ca      if (alloc_stat1 > 0 ) call error(
Ca     +      progname, subname, 'image memory allocation failed')
      mem_pixels_array = 4*mem_size
      mem_total = mem_total + mem_pixels_array
      mem_peak  = max(mem_peak, mem_total)
C      
      mem_size   = (nfc_2d_row +1) * (nfc_2d_col * 2 +1)
      allocate(fftavg(mem_size), stat=alloc_stat1)
      allocate(fft2d(mem_size), stat=alloc_stat2)
      if (alloc_stat1 > 0 .or. alloc_stat2 > 0) call error(
     +     progname, subname, 'fft space memory allocation failed')
      mem_cmpt  = 4*mem_size
      mem_total = mem_total + 3*mem_cmpt
      mem_peak  = max(mem_peak, mem_total)
C --------------------------------------------------------------------
      do i = 1, mem_size
         fftavg(i) = 0.
      enddo
C
      call system_clock(clock2)
      t_init = elapsed_time(clock1, clock2)
C
C *********************************************************************
C *read each image do 2D DFT to fft2d(complex) and average to fftavg(real)*
C *********************************************************************
C
      call vrffti( nrffta_col, rffta_omega )
      itemp  = npix_row*npix_col
      
Ca  RWa Nov 2005 Try and optimize this - if we've calculated
Ca  this before then just use that - don't recalc every time 
      if(calcIt .eq. 1) then
         do i = 1, num_img
C
Cji   read one image
Ca        IMGHEAD.IMGNUM = i
Ca        CALL PIF_READ_DH(IMGHEAD)
Cji        IMGHEAD.MODE= 6
Ca        call rpifimag_f (itemp, pixels)
C

            do m=1,npix_row
               do n=1,npix_col
                  pixels(n,m) = packImgCall(n,m,i) 
               enddo
            enddo

Cji   do 2D DFT
            call fft_2dfft_1d_(pixels, npix_row, npix_col, 
     +           nrffta_omega, rffta_omega, nrffta_row, nrffta_col,
     +           hkl_max, hkl_max, fft2d)
C
Cji   average them   
            do j = 1, mem_size
               fftavg(j) = fftavg(j) + 
     +              sqrt( real(fft2d(j))**2 + aimag(fft2d(j))**2)
               saveFftAvg(j) = fftavg(j)
            enddo
C
         enddo
      else
         do j = 1, mem_size
            fftavg(j) = saveFftAvg(j)
         enddo
      endif                     ! if(calcIt .eq. 1)

Ca      call pif_close (pix_file_unit)
      deallocate (rffta_omega)
      deallocate(fft2d)
Ca      deallocate(pixels)
      mem_total = mem_total - mem_pixels_array - 2*mem_cmpt
C
C *********************************************************************
Cji   allocate memory and caluate some stats
      allocate(CA1D_AVG(hkl_max), stat=alloc_stat1)
      allocate(CA1D_STD(hkl_max), stat=alloc_stat2)
      
      mem_cmpt_intrps = 36 * hkl_max
      mem_total = mem_total + mem_cmpt_intrps
      mem_peak  = max(mem_peak, mem_total)
C
Cji call to calcuate 1D statistic
      call D_STATS(fftavg,hkl_max,IMG_AVG,IMG_STD,CA1D_AVG,CA1D_STD)
      
      deallocate(fftavg)
      mem_total = mem_total - mem_cmpt
C
C *********************************************************************
Cji   calculate ctf values
Cji   note some different with ctf_para.f, because of the unit
      wavelength = 12.264264967 / 
     +     sqrt (voltage + 0.9784663543E-6 * voltage**2 )
      fw2 = (defocus-sqrt(defocus*defocus-Cs*wavelength*2.0))/Cs
      fw = sqrt(fw2)
      annlow = nint(fw*(pixel_size*2*hkl_max)/wavelength)
      if(annlow .lt. 1.0) annlow = 1.0
      reslow= 2.0*hkl_max*pixel_size/annlow
      annhigh = nint (2*hkl_max*pixel_size /res_hi)
      if(annhigh .gt. float(hkl_max)) annhigh = float(hkl_max)
      ndata = annhigh + 1 - annlow
      
      print *, 'wavelength = ', wavelength
      print *, 'annlow     = ', annlow
      print *, 'annhigh    = ', annhigh
      print *, 'reslow     = ', reslow
      print *, 'res_hi     = ', res_hi
      print *, ' '
C     
      call cmpt_fit1d(ca1d_AVG(annlow),ca1d_std(annlow), 
     +     ndata,annlow, annhigh,
     +     poly_paras, poly_order, poly_orderb, poly_orderd,
     +     wavelength, hkl_max, A, Cs, pixel_size, chisq)
c     do i=1,hkl_max
c		write (*,*) i, ca1d_avg(i)
c	enddo
C
C --------------------------------------------------------------------
Cji   print out the result and write files
C
Ca      OPEN (UNIT=11, FILE=outfile, ERR=960)
Ca      goto 961
C
Ca  960 call error(progname, subname,
Ca     +    'Error in opening output file')

C --------------------------------------------------------------------
Cji   open output file ok, print out the head for orientation file.
C
 961  defocus = poly_paras(poly_order) /10000.
Ca      WRITE(11,*) infile
Ca      WRITE(11,1010) pixel_size, 1, voltage, A,
Ca     +            defocus, defocus, 0.0, Cs/10000000
Ca 1010 FORMAT (1X,F8.4,',',I2,',',F10.1,',',4(F10.4,','),F8.2)
Ca      close(UNIT=11)
C --------------------------------------------------------------------

C    A second output file that has the approximation results:
      open (unit=14, file="1d_result.out", err=962)
      goto 963
 962  call error(progname, subname,
     +     'Error in opening output file')
 963  tmp6 = 0.0
      write(14,*) "X,Y,B+CTF^2*D,Y-B,B,CTF*CTF,D"
      do i=1,hkl_max
C     OLDWAY tmp5 =1.5*i/ hkl_max- 1.0 
         tmp5 =2.0*(i-annlow)/(annhigh-annlow) - 1.0;
         
         tmp6 = poly_paras(1)
         tmp6 = tmp6 + poly_paras(2)*tmp5
         tmp6 = tmp6 + poly_paras(3)*(3.0*tmp5*tmp5-1.0)/2.0
         tmp6 = tmp6 + poly_paras(4)*(5.0*tmp5*tmp5*tmp5-3.0
     +        *tmp5)/2.0
         tmp6 = tmp6 + poly_paras(5)
     +        *(5.0*tmp5*tmp5*tmp5*tmp5-30.0*tmp5*tmp5+3.0)/8.0
         tmp6 = tmp6 + poly_paras(6)*(63.0*tmp5*tmp5*tmp5*tmp5
     +        *tmp5-70.0*tmp5*tmp5*tmp5+15.0*tmp5)/8.0
         B = tmp6
         
         tmp6 = poly_paras(7)
         tmp6 = tmp6 + poly_paras(8)*tmp5
         tmp6 = tmp6 + poly_paras(9)*(3.0*tmp5*tmp5-1.0)/2.0
         tmp6 = tmp6 + poly_paras(10)*(5.0*tmp5*tmp5*tmp5-3.0
     +        *tmp5)/2.0
         tmp6 = tmp6 + poly_paras(11)*(5.0*tmp5*tmp5*tmp5*tmp5
     +        -30.0*tmp5*tmp5+3.0)/8.0
         tmp6 = tmp6 + poly_paras(12)*(63.0*tmp5*tmp5*tmp5*tmp5
     +        *tmp5-70.0*tmp5*tmp5*tmp5+15.0*tmp5)/8.0
         
         D =tmp6
         
         fw =wavelength*i/(hkl_max*2.0* pixel_size )
         fw2= fw*fw
         tmp5 = wavelength
         theta = PI*2.0*(Cs*fw2*fw2/4.0-poly_paras(13)*fw2/2.0)/tmp5
         tmp5 = A*A
         ctf = sqrt(1.0-tmp5)*sin(theta)-A*cos(theta)
         ctf2 = ctf*ctf
Ca  Stuff XWindows display buffers
           
         displayScale = int(512.0 / float(fftSizeCall)) 
         adr_s(i*displayScale)       = (B + ctf2 * D)
         adr_sminusb(i*displayScale) = adr_s(i*displayScale) - B
         adr_ctfsq(i*displayScale)   = ctf2
         adr_d(i*displayScale)       = D
         adr_b(i*displayScale)       = B
         ca1d_pass(i*displayScale)   = ca1d_avg(i)
         if (displayScale .gt. 1 .and. (i .lt. 256)) then
            do mm = 1, displayScale
               adr_s(i*displayScale+mm)       = (B + ctf2 * D)
               adr_sminusb(i*displayScale+mm) = adr_s(i*displayScale)-B
               adr_ctfsq(i*displayScale+mm)   = ctf2
               adr_d(i*displayScale+mm)       = D
               adr_b(i*displayScale+mm)       = B
               ca1d_pass(i*displayScale+mm)   = ca1d_avg(i)
            enddo
         endif

c	 write(*,*) i, fw, wavelength, Cs,pi
c	 write(*,*)  fw2,theta, A,ctf
         write(14, 1011)i,ca1d_avg(i),B+ctf2*D,ca1d_avg(i)-B,B,ctf2,D
 1011    FORMAT (1X,I4,',',5(F10.6,','),F10.6)
      enddo
      close(UNIT=14)
      
      defMajorCall = defocus
      chisqCall = chisq
      do j = 1, poly_orderb
         aPass(j) = poly_paras(j)
      enddo
      do j = poly_orderb+1, poly_orderb+poly_orderd+1
         aPass(j) = poly_paras(j)
      enddo
C --------------------------------------------------------------------
      deallocate(ca1d_AVG)
      deallocate(ca1d_std)
      deallocate(poly_paras)
      mem_total = mem_total - mem_cmpt_intrps
      call system_clock(clock3)
      t_interp = elapsed_time(clock2, clock3)
C
C *********************************************************************
C
      if (mem_total .ne. 0) print *,'mem_total=',mem_total,
     +     'At the end, mem_total should be 0!!!'
C
      time = t_init + t_interp
C     
      if (test_time)
     +     print 40, 0, t_init,
     +     t_interp,
     +     time
 40   format (/ 'Node ', i3,
     +     ' Time used in initialization                      =',
     +     f15.4, ' ' / 8x,
     +     ' Time used in read image & 2DFFT & factors        =',
     +     f15.4, ' ' / 8x,
     +     ' Total time used                                  =',
     +     f15.4)
C     
C     Print memory allocating message.
C     
      if (test_memory) print 60, 0, mem_peak,
     +     mem_pixels_array, mem_cmpt ,mem_cmpt_intrps
 60   format(/ 'Node ', i3, ' Memory allocation in BYTES:', /
     +     8x, ' Peak memory allocated   =', f18.1 /
     +     8x, ' Memory for 3D Map       =', f18.1 /
     +     8x, ' Memory for 3D FFT       =', f18.1 /
     +     8x, ' Memory used in CMPCC    =', f18.1 )
C     
      print *, '**********finished nicely**********'
Ca      stop
      end

      subroutine error(a,b,c)
      character*256 a,b,c
      print *, a,b,c
      return
      end
C **********************************************************************
C *              *****     SUBROUTINE D_STATS     *****                *
C *                                                                    *
C *    ROUTINE TO DETERMINE THE MIN/MAX, AVERAGE AND STD FOR VALUES    *
C *     IN THE "FFT" real ARRAY.                                       *
C *    the array is (0:hkl_max, -hkl_max:hkl_max) of real              *
C **********************************************************************

      SUBROUTINE  D_STATS( fftavg, hkl_max, MAP_AVG, MAP_STD, 
     +                     CA1D_AVG, CA1D_STD)
C
      IMPLICIT NONE
      include '../include/vax_minmax.inc'
C
Cji  arguments
      integer hkl_max
      real fftavg(0:hkl_max, -hkl_max:hkl_max)    
      double precision  CA1D_AVG(hkl_max), CA1D_STD(hkl_max)
      real MAP_STD, MAP_AVG
C
Cji local 
      REAL MAP_MIN, MAP_MAX, R, X, PNT, VAR
      REAL  CA1D_CNT(hkl_max)
      INTEGER  I, J, RI, array_size
      double precision TOT, SUMSQ
C
       MAP_MIN  = R4_MAX
       MAP_MAX  = R4_MIN
       SUMSQ    = 0.0
       TOT      = 0.0
C
       DO I = 1, hkl_max
         CA1D_AVG(I) = 0.0
         CA1D_STD(I) = 0.0
         CA1D_CNT(I) = 0.0
       ENDDO
C
       DO I = 0, hkl_max
         DO J = - hkl_max, hkl_max
           X       = fftavg(I, J)
           SUMSQ   = SUMSQ + X**2
           TOT     = TOT + X
           MAP_MIN = AMIN1(MAP_MIN,X)
           MAP_MAX = AMAX1(MAP_MAX,X)

           R  = SQRT (float(I*I + J*J))
           RI = int(R)
C        
           IF ((RI.LT.hkl_max).AND.(RI.NE.0)) THEN

             PNT = 1.0 - (R - RI)
             CA1D_AVG(RI) = CA1D_AVG(RI) + X*PNT
             CA1D_CNT(RI) = CA1D_CNT(RI) + PNT
             CA1D_STD(RI) = CA1D_STD(RI) + X*X*PNT
             CA1D_AVG(RI+1) = CA1D_AVG(RI+1) + X*(1.0-PNT)
             CA1D_CNT(RI+1) = CA1D_CNT(RI+1) + 1.0 - PNT
             CA1D_STD(RI+1) = CA1D_STD(RI+1) + X*X*(1.0-PNT)
           elseif (RI.EQ.hkl_max) THEN
C        
             PNT = 1.0 - (R - RI)
             CA1D_AVG(RI) = CA1D_AVG(RI) + X*PNT
             CA1D_CNT(RI) = CA1D_CNT(RI) + PNT
             CA1D_STD(RI) = CA1D_STD(RI) + X*X*PNT
           ENDIF
C       
         ENDDO
       ENDDO
C
       ARRAY_SIZE= (hkl_max +1)*(2*hkl_max + 1)
       MAP_AVG = TOT/FLOAT(ARRAY_SIZE)
       MAP_STD = 0.0
       VAR     = (SUMSQ/FLOAT(ARRAY_SIZE))-(MAP_AVG*MAP_AVG)
       IF(VAR.GE.0.0) MAP_STD = SQRT(VAR)
       WRITE(*,1000)
       WRITE(*,1001)
 1000  FORMAT('                  STATICS: averaged FFT')
 1001  FORMAT('FFTSIZE   MINIMUM     MAXIMUM        AVERAGE        STD',
     1 /,' ------------------------------------------------------',/)
C
       WRITE(*,*)hkl_max, MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD
c
       DO I = 1, hkl_max
         CA1D_AVG(I)=CA1D_AVG(I)/CA1D_CNT(I)
         CA1D_STD(I)=CA1D_STD(I)/CA1D_CNT(I)
         CA1D_STD(I)=CA1D_STD(I)-CA1D_AVG(I)*CA1D_AVG(I)
         IF(CA1D_STD(I).GE.0.0) THEN
           CA1D_STD(I)= SQRT (CA1D_STD(I))
         ELSE
           PRINT *, 'CHECK YOUR DATA!'
         ENDIF
C
         CA1D_AVG(I) = CA1D_AVG(I)/map_avg
         CA1D_STD(I) = CA1D_STD(I)/map_avg
Cji         WRITE(LUN_CA1D,*)I, CA1D(I)/map_avg, CA1D_STD(I)/map_avg
         print *, I, CA1D_AVG(I), CA1D_STD(I)
C
       ENDDO
C
      return
      end
      subroutine fft_2dfft_1d_(pixels, npix_row, npix_col,
     +             nrfft_omega, rfft_omega, nrfft_row, 
     +             nrfft_col, nfc_2d_row, 
     +             nfc_2d_col, fc_2d )
C
      implicit none
      include '../include/allprogs.inc'
C
C Arguments
      integer*4 npix_row, npix_col, nrfft_row, nrfft_col, nrfft_omega,
     +        nfc_2d_row, nfc_2d_col
      complex fc_2d( 0:nfc_2d_row, -nfc_2d_col:nfc_2d_col )
      real*4  pixels(npix_row, npix_col), rfft_omega(nrfft_omega)
C
C Local
      integer*4 icol, irow, icol_a, icol_a_1, irow_a_1, irow_b_1_rfft,
     +        icol_c, icol_c_1_rfft, irow_c_1_rfft, irow_d_1,
     +        icol_rfft, h, k, num_cols_a, num_rows_a, num_rows_b,
     +        num_cols_c, num_rows_c, num_rows_d, nfc_2d_end,
     +        nrfft_d2,
     +        nrfft_trns_row, nrfft_trns_col

      real*4 rfft(nrfft_row,nrfft_col),rfft_trns(nrfft_col,nrfft_row)
      real*4    cc, ss, sc, cs 
      character*9 subname
      data        subname / 'FFTANALY' /
C
      external vrffti, vrfftf
C**********************************************************************
C
      nrfft_trns_row = nrfft_col    
      nrfft_trns_col = nrfft_row
C
C     The PIXELS array is square.
C
C     The array, PIXELS( 1:NPIX_ROW 1:NPIX_COL) is     --------- cols
C     partitioned into 4 arrays A, B, C, D:            | C | B |
C         A has nonnegative u and v coordinates        ----------- v
C         B has negative u, nonnegative v              | D | A |    
C         C has negative u and v                       ----|----   
C         D has nonnegative u and negative v           |   |   |
C                                                      |   | 
C                                                    rows  u 
C 
C     Transfer and rearrange PIXELS to the larger work array RFFT
C     and fill the rest of RFFT with zeros.
C
C     After rearrangement, the pixel values are      --------------- v
C     stored in RFFT as indicated to the right:      | A | 0 | D |
C                                                    -------------
C                                                    | 0 | 0 | 0 |
C                                                    -------------
C                                                    | B | 0 | C |
C                                                    -------------
C                                                    |
C                                                    u
C
      irow_a_1   = ifix((npix_row -1)/2. ) + 1
      icol_a_1   = ifix((npix_col -1)/2. ) + 1
      num_rows_a = npix_row + 1 - irow_a_1
      num_cols_a = npix_col + 1 - icol_a_1
C 
C     The first row number of A in PIXELS is the same as the first row
C     number of D in PIXELS.
C
      irow_d_1   = irow_a_1
C 
C     The first column number of A in PIXELS is the same as the first
C     column number of B in PIXELS
C     The number of rows of D is the same as the number of rows of A
C
      num_rows_d = num_rows_a
C
C     The number of columns of B and A are the same.
C     Find the number of rows and columns of C --- these are each
C     one less than the first row and column number of A in PIXELS
C
      num_rows_c    = irow_a_1 - 1
      num_cols_c    = icol_a_1 - 1
C
C     Find the first row and column numbers of C in array RFFT.
C
      irow_c_1_rfft = nrfft_row + 1 - num_rows_c
      icol_c_1_rfft = nrfft_col + 1 - num_cols_c
C
C     The first column number of C in RFFT is the same as the first
C     column number of D in RFFT.
C     The number of the first row of C in RFFT is the same as the
C     number of the first row of B in RFFT
C 
C     The number of rows of B is the same as the number of rows of C
C
      num_rows_b    = num_rows_c
C
C     The first row of B in RFFT is the same as the first row of C
C
      irow_b_1_rfft = irow_c_1_rfft
C 
C     Zero RFFT
C
      do 1010 icol = 1, nrfft_col
        do 1000 irow = 1, nrfft_row
          rfft( irow, icol ) = 0.
 1000   continue
 1010 continue
      
C
C     Use the BLAS routine SCOPY to copy real vectors from one location
C     to another.
C     Syntax:
C       SCOPY(vector_length,input_vector,stride,output_vector,stride)
C
      icol_rfft = 0
      do 1020 icol_a = icol_a_1, npix_col
        icol_rfft = icol_rfft + 1
C
C       Copy a column of A in PIXELS to a column of A in RFFT.
C
        call scopy( num_rows_a, pixels(irow_a_1,icol_a), 1,
     +                          rfft(1,icol_rfft),  1 )
C
C       Copy a column of B in PIXELS to a column of B in RFFT.
C
        call scopy( num_rows_b, pixels(1,icol_a), 1,
     +                          rfft(irow_b_1_rfft,icol_rfft), 1 )
 1020 continue
C
      icol_rfft = icol_c_1_rfft - 1
      do 1030 icol_c = 1, num_cols_c
        icol_rfft = icol_rfft + 1
C
C       Copy a column of C in PIXELS to a column of C in RFFT.
C
        call scopy( num_rows_c, pixels(1,icol_c), 1,
     +                          rfft(irow_c_1_rfft,icol_rfft), 1 )
C
C       Copy a column of D in PIXELS to a column of D in RFFT.
C
        call scopy( num_rows_d, pixels(irow_d_1,icol_c), 1,
     +                          rfft(1,icol_rfft), 1 )
 1030 continue
C 
C     Carry out real FFT analysis (foward transformation) of each row
C     of  RFFT.
C
C     Transformation parameters, RFFT_OMEGA, were computed the first
C     time this routine (FFTANALY) is called.  The values in RFFT_OMEGA
C     must not change between successive calls of VRFFTF unless the
C     size of RFFT changes.  The input is the array RFFT of rearranged
C     pixel values and a work array RFFT_TRNS.  The transformation is
C     with respect to the column index, V, which becomes the index K of
C     the Fourier coefficients.  The Fourier coefficents are returned in
C     RFFT whose column coordinate is now K and whose row coordinate
C     remains U.
C 
      if( npix_row .lt. nrfft_row ) then
C
C       Array RFFT has more rows than PIXELS; array RFFT contains
C       rows of zeros --- do not transform the rows of zeros.
C                                                            CALL VRFFTF
C                                                            ***********
C       Find Fourier coefficients of rows containing A and D.
C
        call vrfftf(num_rows_a, nrfft_col,
     +              rfft(1,1), rfft_trns(1,1),
     +              nrfft_col, rfft_omega)
C
C       Find Fourier coefficients of rows containing B and C.
C
        call vrfftf(num_rows_c, nrfft_col,
     +              rfft(irow_c_1_rfft,1), rfft_trns(irow_c_1_rfft,1),
     +              nrfft_col, rfft_omega)
      else
C
C       Array RFFT has same number of rows as PIXELS.  Find Fourier
C       coefficients of each row of RFFT
C
        call vrfftf(nrfft_row, nrfft_col,
     +              rfft(1,1), rfft_trns(1,1),
     +              nrfft_col, rfft_omega)
      endif
C 
C     See NOTE #2 at end of this subroutine.
C 
C     Transpose RFFT and store the transpose in RFFT_TRNS.  The column
C     index of RFFT_TRNS is U and its row index is K.
C
      do 1050 irow = 1, nrfft_row
        do 1040 icol = 1, nrfft_col
          rfft_trns(icol,irow) = rfft(irow,icol)
 1040   continue
 1050 continue
C 
C     Carry out a real FFT analysis (foward transformation) of each row
C     of RFFT_TRNS, i.e., with respect to U and the index of the Fourier
C     coefficients is H.  The Fourier coefficients are returned in
C     RFFT_TRNS whose column coordinate is now H and row index is K.
C
C                                                            CALL VRFFTF
C                                                            ***********
      call vrfftf(nrfft_trns_row, nrfft_trns_col,
     +            rfft_trns(1,1), rfft(1,1),
     +            nrfft_col, rfft_omega)
C 
C     Zero the complex output array                  ---------- k
C     FC_2D( 0:NFC_2d_ROW, -NFC_2D_COL:NFC_2D_COL )  |   |   |
C                                                    ----|----
C                                                        |
C                                                        h
C 
      do 1070 icol = -nfc_2d_col, nfc_2d_col
        do 1060 irow = 0, nfc_2d_row
          fc_2d( irow, icol ) = ( 0., 0. )
 1060   continue
 1070 continue

C 
C     The complex array FC_2D( 0:NFC_2D_ROW, -NFC_2D_COL:NFC_2D_COL )
C     will contain the complex valued Fourier coefficients of the
C     real values which were originally stored in RFFT (obtained
C     by rearranging the pixel values and zero fill).  The current
C     real values in the array RFFT_TRNS(1:NRFFT_COL, 1:NRFFT_ROW)
C     have to be combined to get the complex valued Fourier
C     coefficients.  The Fourier coefficients are periodic with periods
C     COL_PERIOD = 2*NFC_2D_COL and ROW_PERIOD = 2*NFC_2D_ROW
C
C     See NOTE #3 at end of this subroutine.
C
C     Set the value of the complex Fourier coefficient at the origin.
C
      fc_2d( 0, 0 ) = cmplx( rfft_trns( 1, 1), 0.)
C
      nrfft_d2 = nrfft_trns_col / 2
C
CXXXXXif( 2*nrfft_d2 .eq. nrfft_trns_col ) then
CXXXXXIn this version, only even NRFFT_TRNS_COL is allowed.
C       There is an even number of rows and colums in RFFT.
C       NFC_2D_END is equal to NRFFT_D2
C
        nfc_2d_end = nrfft_d2
C
C       Set complex value at end of H-axis.
C
        fc_2d(nrfft_d2, 0) = cmplx( rfft_trns(1,nrfft_trns_col), 0.)
C 
C       Set complex values at four corners; use periodicity.
C
        fc_2d(0, nrfft_d2) = cmplx(rfft_trns(nrfft_trns_row,1), 0.)
        fc_2d(0,-nrfft_d2) = fc_2d(0, nrfft_d2)
        fc_2d(nrfft_d2, nrfft_d2)
     +    = cmplx(rfft_trns(nrfft_trns_row,nrfft_trns_col), 0.)
        fc_2d(nrfft_d2,-nrfft_d2) = fc_2d(nrfft_d2, nrfft_d2)

C       Set rest of values along along H = 0 and H = NRFFT_D2
C
        do 1080 k = 1, nrfft_d2 - 1
          cc                    = rfft_trns( 2*k,   1 )
          sc                    = rfft_trns( 2*k+1, 1 )
          fc_2d( 0,  k )        = cmplx( cc, sc )
C
C         FFT of real function is conjugate symmetric.
C
          fc_2d( 0, -k )        = cmplx( cc,-sc )

          cc                    = rfft_trns( 2*k,   nrfft_row )
          sc                    = rfft_trns( 2*k+1, nrfft_row )
          fc_2d( nrfft_d2, k ) = cmplx( cc, sc )
C
C         FFT of real function is conjugate symmetric.
C
          fc_2d( nrfft_d2,-k ) = cmplx( cc,-sc )
 1080   continue

C       Set rest of values along along K = 0 and K =   NRFFT_D2
C       and use periodicity to set values along  K = - NRFFT_D2
C
        do 1090 h = 1, (nrfft_d2 - 1)
          cc                    = rfft_trns( 1, 2*h   )
          cs                    = rfft_trns( 1, 2*h+1 )
          fc_2d( h, 0 )         = cmplx( cc, cs )
          cc                    = rfft_trns( nrfft_col, 2*h   )
          cs                    = rfft_trns( nrfft_col, 2*h+1 )
          fc_2d( h, nrfft_d2 ) = cmplx( cc, cs )
C
C         Impose periodic conditions.
C
          fc_2d( h,-nrfft_d2 ) = cmplx( cc, cs )
 1090   continue

C       Fill FC_2D for  H =  1, 2, ... ,  NRFFT_D2 - 1
C                       K =  1, 2, ... ,  NRFFT_D2 - 1
C                       K = -1,-2, ... , -NRFFT_D2 + 1
 
        do 1110 k = 1, (nrfft_d2 - 1)
          do 1100 h = 1, (nrfft_d2 - 1)
            cc            = rfft_trns( 2*k,   2*h   )
            ss            = rfft_trns( 2*k+1, 2*h+1 )
            sc            = rfft_trns( 2*k+1, 2*h   )
            cs            = rfft_trns( 2*k,   2*h+1 )
            fc_2d( h, k ) = cmplx( cc - ss,  sc + cs )
            fc_2d( h,-k ) = cmplx( cc + ss, -sc + cs )
 1100     continue
 1110   continue

      return
      end
Cji check the usage argument, and print out usage        

        subroutine usage

        implicit none
        character arg*20
        integer   i

        i = 1
        call getarg( i, arg ) 
        if ( arg(1:6).eq.'-usage' .or. 
     +       arg(1:6).eq.'-Usage' .or. 
     +       arg(1:6).eq.'-USAGE' ) then
         print *,'Ctffit version 1.0, Feb. 4 2004'
         print *,'Cftfit -usage:'
         print *,'  Cftfit < stdin_ctrl_file > stdout_file'
         print *,  'See http://bond.cs.ucf.edu/ComputationalBiology/ for
     + detail'
         print *,''
          stop
        endif

        return
        end
 
        
